
package main

import (
   "fmt"
   "time"
)

var msg = make(chan string)

func pitcher() { // this posts messages to the global channel
   fmt.Printf(">> producer starting\n")
   time.Sleep(4*time.Second)
   msg <- "tiken"
   time.Sleep(4*time.Second)
   msg <- "token"
   time.Sleep(4*time.Second)
   msg <- "halt"
   time.Sleep(4*time.Second)
   fmt.Println(">> producer done")

}

func catcher() { // this waits to receive messages on the global channel
   var m string
   fmt.Printf(">> consumer starting\n")
   for {
      m = <- msg
      fmt.Printf("  ... received: %s\n", m)
      if m=="halt" { break }
   }
   fmt.Println(">> consumer done")
}

func main() { // every go program is at least one goroutine, the main
   // fire off 2 more goroutines
   go pitcher(); time.Sleep(time.Second); go catcher()
   // wait awhile for them to talk to each other
   // they are using a single global channel
   time.Sleep(20 * time.Second)
   // and end the main goroutine
   fmt.Println("\nend main function")
}
