
package main

import (
   "fmt"
   "time"
   "math/rand"
)

var msg = make(chan string)

func mGen() { // this posts messages to the global channel
   fmt.Printf(">> generator starting\n")
   time.Sleep(2*time.Second)
   msg <- "tiken"; msg <- "token"; msg <- "winken"; msg <- "blinken"
   msg <- "halt"; 
   msg <- "nod"; msg <- "Go Heels"; msg <- "Beet Dook"; 
   msg <- "winter"; msg <- "holiday"; msg <- "alpha"; 
   msg <- "halt";
   msg <- "beta"; msg <- "gamma"; msg <- "delta"; msg <- "epsilon";

   time.Sleep(time.Second)
   msg <- "halt"
   //msg <- "halt"  // add this and the goroutine does not complete
   fmt.Println(">> producer done")
}

func getA() { // this waits to receive messages on the global channel
   for {
      time.Sleep(time.Duration(rand.Intn(2000)) * time.Millisecond); 
      m := <- msg
      fmt.Printf("  A ... received: %s\n", m)
      if m=="halt" { fmt.Println(">> getA done"); return }
   }
   fmt.Println(">> getA done")
}

func getB() { // this waits to receive messages on the global channel
   for {
      time.Sleep(time.Duration(rand.Intn(2000)) * time.Millisecond); 
      m := <- msg
      fmt.Printf("  B ... received: %s\n", m)
      if m=="halt" { fmt.Println(">> getB done"); return }
   }
}
func getC() { // this waits to receive messages on the global channel
   for {
      time.Sleep(time.Duration(rand.Intn(2000)) * time.Millisecond); 
      m := <- msg
      fmt.Printf("  C ... received: %s\n", m)
      if m=="halt" {  fmt.Println(">> getC done"); return }
   }
}

func main() { // every go program is at least one goroutine, the main
   // fire off 3 consumers, one generator, using a global channel
   go getA(); go getB(); go getC(); go mGen()
   time.Sleep(15 * time.Second)
   // and end the main goroutine
   fmt.Println("\nend main function")
}
