/*
  does wait groups by passing a wait group to each goroutine
  must pass wg as pointer
  equivalent to wait2.go
*/
package main
import ( 
   "fmt" 
   "sync"
   "time" 
)
func worker(id int, w *sync.WaitGroup) {  // must pass wg as a poiner
   fmt.Printf("Worker %d starting\n", id)
   time.Sleep(4*time.Second)
   w.Done()  // dec the wg counter
   fmt.Printf("Worker %d done\n", id)
}
func main() {
   var wg sync.WaitGroup
   for i := 1; i <= 5; i++ {
      wg.Add(1)  // inc the wg counter
      go worker(i,&wg)  // pass a pointer to wg
   } 
   fmt.Println("main is ready to end but we will wait...")
   fmt.Println("ending now would kill gorutines still running")
   time.Sleep(2*time.Second)  // is this long enough??  maybe... maybe not
   //wg.Wait()  // do the synch ... wait for all in group to end
   fmt.Println("ok main is done")
}
