/* 
  uses closures to do wait groups
  wg management is centralized in one function
  also shows "defer"
  equivalent to wait.go

*/

package main

import (
   "fmt"
   "sync"
   "time"
)

func worker(id int) {
   fmt.Printf("Worker %d starting\n", id)
   time.Sleep(4*time.Second)
   fmt.Printf("Worker %d done\n", id)
}

func main() {
   var wg sync.WaitGroup
   for i := 1; i <= 5; i++ {
      wg.Add(1) // inc wg counter when goroutine is about to be made
      go func(i int) {
            defer wg.Done()  // dec wg counter when goroutine ends
            worker(i)
         }(i)
   }
   fmt.Println("main is ready to end, but we will wait...")
   fmt.Println("ending now would kill gorutines still running")
   time.Sleep(2*time.Second)  // is this long enough?? 
                              // maybe... maybe not
   //wg.Wait()  // the synch... the wait on the group counter
   fmt.Println("ok main is done")
}
